Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -10218,607 +9830,7 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb, nzt+1
+                   DO  k = nzb_do, nzt_do
                       local_pf(i,j,k) = MERGE( PM10_av(k,j,i),                 &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin1' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(1)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,1),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin2' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1 
-                      local_pf(i,j,k) = MERGE( aerosol_number(2)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,2),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin3' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(3)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,3),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin4' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1    
-                      local_pf(i,j,k) = MERGE( aerosol_number(4)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,4),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(5)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,5),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin6' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(6)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,6),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin7' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(7)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,7),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin8' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                  
-                      local_pf(i,j,k) = MERGE( aerosol_number(8)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,8),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin9' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(9)%conc(k,j,i),  &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,9),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'N_bin10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(10)%conc(k,j,i), &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,10),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin11' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(11)%conc(k,j,i), &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,11),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'N_bin12' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( aerosol_number(12)%conc(k,j,i), &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,12),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin1' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 1, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,1),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin2' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 2, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,2),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin3' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 3, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,3),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin4' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 4, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,4),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin5' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 5, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,5),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin6' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 6, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,6),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin7' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 7, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,7),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin8' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 8, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,8),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin9' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 9, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,9),              &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-       
-       CASE ( 'm_bin10' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 10, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,10),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin11' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 11, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,11),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-          
-       CASE ( 'm_bin12' )
-          IF ( av == 0 )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1   
-                      temp_bin = 0.0_wp
-                      DO  c = 12, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
-                      ENDDO
-                      local_pf(i,j,k) = MERGE( temp_bin,                       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) )
-                   ENDDO
-                ENDDO
-             ENDDO
-          ELSE
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb, nzt+1                      
-                      local_pf(i,j,k) = MERGE( mbins_av(k,j,i,12),             &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                    ENDDO
@@ -10833,5 +9845,5 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
+                      DO  k = nzb_do, nzt_do
                          temp_bin = 0.0_wp
                          DO  c = ( icc-1 )*nbins+1, icc*nbins                          
@@ -10839,5 +9851,5 @@
                          ENDDO
                          local_pf(i,j,k) = MERGE( temp_bin,                    &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                       ENDDO
@@ -10854,7 +9866,7 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb, nzt+1                      
+                      DO  k = nzb_do, nzt_do                      
                          local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),       &
-                                               REAL( -999.0_wp, KIND = wp ),   &
+                                               REAL( fill_value, KIND = wp ),  &
                                                BTEST( wall_flags_0(k,j,i), 0 ) ) 
                       ENDDO
@@ -10878,34 +9890,45 @@
  SUBROUTINE salsa_data_output_mask( av, variable, found, local_pf )
  
+    USE arrays_3d,                                                             &
+        ONLY:  tend
+ 
     USE control_parameters,                                                    &
-        ONLY:  mask_size_l, mid
+        ONLY:  mask_size_l, mask_surface, mid
+        
+    USE surface_mod,                                                           &
+        ONLY:  get_topography_top_index_ji       
  
     IMPLICIT NONE
     
-    CHARACTER (LEN=*) ::  variable   !< 
-
-    INTEGER(iwp) ::  av   !< 
-    INTEGER(iwp) ::  c    !<
-    INTEGER(iwp) ::  i    !<
-    INTEGER(iwp) ::  icc  !< index of a chemical compound
-    INTEGER(iwp) ::  j    !< 
-    INTEGER(iwp) ::  k    !< 
-    INTEGER(iwp) ::  n    !<
-
-    LOGICAL  ::  found    !< 
-    REAL(wp) ::  df       !< For calculating LDSA: fraction of particles 
-                          !< depositing in the alveolar (or tracheobronchial)
-                          !< region of the lung. Depends on the particle size 
-    REAL(wp) ::  mean_d       !< Particle diameter in micrometres
-    REAL(wp) ::  nc       !< Particle number concentration in units 1/cm**3
-
-    REAL(wp),                                                                  &
-       DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  &
-          local_pf   !< 
-    REAL(wp) ::  temp_bin   !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< points to 
-                                                     !< selected output variable
+    CHARACTER(LEN=5) ::  grid      !< flag to distinquish between staggered grid
+    CHARACTER(LEN=*) ::  variable  !< 
+    CHARACTER(LEN=7) ::  vari      !< trimmed format of variable
+
+    INTEGER(iwp) ::  av              !< 
+    INTEGER(iwp) ::  b               !< loop index for aerosol size number bins
+    INTEGER(iwp) ::  c               !< loop index for chemical components
+    INTEGER(iwp) ::  i               !< loop index in x-direction
+    INTEGER(iwp) ::  icc             !< index of a chemical compound
+    INTEGER(iwp) ::  j               !< loop index in y-direction
+    INTEGER(iwp) ::  k               !< loop index in z-direction
+    INTEGER(iwp) ::  topo_top_ind    !< k index of highest horizontal surface
+    
+    LOGICAL ::  found      !< 
+    LOGICAL ::  resorted   !<
+    
+    REAL(wp) ::  df        !< For calculating LDSA: fraction of particles 
+                           !< depositing in the alveolar (or tracheobronchial)
+                           !< region of the lung. Depends on the particle size 
+    REAL(wp) ::  mean_d    !< Particle diameter in micrometres
+    REAL(wp) ::  nc        !< Particle number concentration in units 1/cm**3
+    REAL(wp) ::  temp_bin  !< temporary array for calculating output variables    
+
+    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  local_pf   !< 
+    
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
 
     found     = .TRUE.
+    resorted  = .FALSE.
+    grid      = 's'
     temp_bin  = 0.0_wp
 
